Package org.apache.commons.io.input

# Class XmlStreamReader

java.lang.Object
java.io.Reader
org.apache.commons.io.input.XmlStreamReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Readable`

public class XmlStreamReader extends Reader
Character stream that handles all the necessary Voodoo to figure out the charset encoding of the XML document within the stream.

IMPORTANT: This class is not related in any way to the org.xml.sax.XMLReader. This one IS a character stream.

All this has to be done without consuming characters from the stream, if not the XML parser will not recognized the document as a valid XML. This is not 100% true, but it's close enough (UTF-8 BOM is not handled by all parsers right now, XmlStreamReader handles it and things work in all parsers).

The XmlStreamReader class handles the charset encoding of XML documents in Files, raw streams and HTTP streams by offering a wide set of constructors.

By default the charset encoding detection is lenient, the constructor with the lenient flag can be used for a script (following HTTP MIME and XML specifications). All this is nicely explained by Mark Pilgrim in his blog, Determining the character encoding of a feed.

To build an instance, use `XmlStreamReader.Builder`.

Originally developed for ROME under Apache License 2.0.

Since:
  2.0
See Also:
  - `XmlStreamReader.Builder`
  - `XmlStreamWriter`

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `XmlStreamReader.Builder`
  Builds a new `XmlStreamWriter`.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Pattern`
  `ENCODING_PATTERN`
  Pattern capturing the encoding of the `'xml'` processing instruction.

  ### Fields inherited from class java.io.Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `XmlStreamReader(File file)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(InputStream inputStream)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(InputStream inputStream, boolean lenient)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(InputStream inputStream, boolean lenient, String defaultEncoding)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(InputStream inputStream, String httpContentType)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(InputStream inputStream, String httpContentType, boolean lenient)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(InputStream inputStream, String httpContentType, boolean lenient, String defaultEncoding)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
  `XmlStreamReader(URL url)`
  Constructs a Reader using the InputStream of a URL.
  `XmlStreamReader(URLConnection urlConnection, String defaultEncoding)`
  Constructs a Reader using the InputStream of a URLConnection.
  `XmlStreamReader(Path file)`
  Deprecated.
  Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static XmlStreamReader.Builder`
  `builder()`
  Constructs a new `XmlStreamReader.Builder`.
  `void`
  `close()`
  Closes the XmlStreamReader stream.
  `String`
  `getDefaultEncoding()`
  Gets the default encoding to use if none is set in HTTP content-type, XML prolog and the rules based on content-type are not adequate.
  `String`
  `getEncoding()`
  Gets the charset encoding of the XmlStreamReader.
  `int`
  `read(char[] buf, int offset, int len)`
  Reads the underlying reader's `read(char[], int, int)` method.

  ### Methods inherited from class java.io.Reader

  `mark, markSupported, read, read, read, ready, reset, skip`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### ENCODING_PATTERN

    public static final Pattern ENCODING_PATTERN
    Pattern capturing the encoding of the `'xml'` processing instruction.

    See also the NT-EncName XML specification.

    Note the documented pattern is:

         EncName   ::=   [A-Za-z] ([A-Za-z0-9._] | '-')*

    However this does not match all the aliases that are supported by Java. For example, `'437'`, `'ISO_8859-1:1987'` and `'ebcdic-de-273+euro'`.

- ## Constructor Details

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(File file) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader for a File.

    It looks for the UTF-8 BOM first, if none sniffs the XML prolog charset, if this is also missing defaults to UTF-8.

    It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

    Parameters:
      `file` - File to create a Reader from.
    Throws:
      `NullPointerException` - if the input is `null`.
      `IOException` - thrown if there is a problem reading the file.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(InputStream inputStream) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader for a raw InputStream.

    It follows the same logic used for files.

    It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

    Parameters:
      `inputStream` - InputStream to create a Reader from.
    Throws:
      `NullPointerException` - if the input stream is `null`.
      `IOException` - thrown if there is a problem reading the stream.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(InputStream inputStream, boolean lenient) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader for a raw InputStream.

    It follows the same logic used for files.

    If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

    If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

    Else if the XML prolog had a charset encoding that encoding is used.

    Else if the content type had a charset encoding that encoding is used.

    Else 'UTF-8' is used.

    If lenient detection is indicated an XmlStreamReaderException is never thrown.

    Parameters:
      `inputStream` - InputStream to create a Reader from.
      `lenient` - indicates if the charset encoding detection should be relaxed.
    Throws:
      `NullPointerException` - if the input stream is `null`.
      `IOException` - thrown if there is a problem reading the stream.
      `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specification.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(InputStream inputStream, boolean lenient, String defaultEncoding) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader for a raw InputStream.

    It follows the same logic used for files.

    If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

    If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

    Else if the XML prolog had a charset encoding that encoding is used.

    Else if the content type had a charset encoding that encoding is used.

    Else 'UTF-8' is used.

    If lenient detection is indicated an XmlStreamReaderException is never thrown.

    Parameters:
      `inputStream` - InputStream to create a Reader from.
      `lenient` - indicates if the charset encoding detection should be relaxed.
      `defaultEncoding` - The default encoding
    Throws:
      `NullPointerException` - if the input stream is `null`.
      `IOException` - thrown if there is a problem reading the stream.
      `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specification.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(InputStream inputStream, String httpContentType) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader using an InputStream and the associated content-type header.

    First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

    It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

    Parameters:
      `inputStream` - InputStream to create the reader from.
      `httpContentType` - content-type header to use for the resolution of the charset encoding.
    Throws:
      `NullPointerException` - if the input stream is `null`.
      `IOException` - thrown if there is a problem reading the file.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(InputStream inputStream, String httpContentType, boolean lenient) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader using an InputStream and the associated content-type header. This constructor is lenient regarding the encoding detection.

    First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

    If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

    If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

    Else if the XML prolog had a charset encoding that encoding is used.

    Else if the content type had a charset encoding that encoding is used.

    Else 'UTF-8' is used.

    If lenient detection is indicated an XmlStreamReaderException is never thrown.

    Parameters:
      `inputStream` - InputStream to create the reader from.
      `httpContentType` - content-type header to use for the resolution of the charset encoding.
      `lenient` - indicates if the charset encoding detection should be relaxed.
    Throws:
      `NullPointerException` - if the input stream is `null`.
      `IOException` - thrown if there is a problem reading the file.
      `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specification.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(InputStream inputStream, String httpContentType, boolean lenient, String defaultEncoding) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader using an InputStream and the associated content-type header. This constructor is lenient regarding the encoding detection.

    First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

    If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

    If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

    Else if the XML prolog had a charset encoding that encoding is used.

    Else if the content type had a charset encoding that encoding is used.

    Else 'UTF-8' is used.

    If lenient detection is indicated an XmlStreamReaderException is never thrown.

    Parameters:
      `inputStream` - InputStream to create the reader from.
      `httpContentType` - content-type header to use for the resolution of the charset encoding.
      `lenient` - indicates if the charset encoding detection should be relaxed.
      `defaultEncoding` - The default encoding
    Throws:
      `NullPointerException` - if the input stream is `null`.
      `IOException` - thrown if there is a problem reading the file.
      `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specification.

  - ### XmlStreamReader

    @Deprecated public XmlStreamReader(Path file) throws IOException
    Deprecated.
    Use `builder()`, `XmlStreamReader.Builder`, and `XmlStreamReader.Builder.get()`
    Constructs a Reader for a File.

    It looks for the UTF-8 BOM first, if none sniffs the XML prolog charset, if this is also missing defaults to UTF-8.

    It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

    Parameters:
      `file` - File to create a Reader from.
    Throws:
      `NullPointerException` - if the input is `null`.
      `IOException` - thrown if there is a problem reading the file.
    Since:
      2.11.0

  - ### XmlStreamReader

    public XmlStreamReader(URL url) throws IOException
    Constructs a Reader using the InputStream of a URL.

    If the URL is not of type HTTP and there is not 'content-type' header in the fetched data it uses the same logic used for Files.

    If the URL is a HTTP Url or there is a 'content-type' header in the fetched data it uses the same logic used for an InputStream with content-type.

    It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

    Parameters:
      `url` - URL to create a Reader from.
    Throws:
      `NullPointerException` - if the input is `null`.
      `IOException` - thrown if there is a problem reading the stream of the URL.

  - ### XmlStreamReader

    public XmlStreamReader(URLConnection urlConnection, String defaultEncoding) throws IOException
    Constructs a Reader using the InputStream of a URLConnection.

    If the URLConnection is not of type HttpURLConnection and there is not 'content-type' header in the fetched data it uses the same logic used for files.

    If the URLConnection is a HTTP Url or there is a 'content-type' header in the fetched data it uses the same logic used for an InputStream with content-type.

    It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

    Parameters:
      `urlConnection` - URLConnection to create a Reader from.
      `defaultEncoding` - The default encoding
    Throws:
      `NullPointerException` - if the input is `null`.
      `IOException` - thrown if there is a problem reading the stream of the URLConnection.

- ## Method Details

  - ### builder

    public static XmlStreamReader.Builder builder()
    Constructs a new `XmlStreamReader.Builder`.
    Returns:
      a new `XmlStreamReader.Builder`.
    Since:
      2.12.0

  - ### close

    public void close() throws IOException
    Closes the XmlStreamReader stream.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Specified by:
      `close` in class `Reader`
    Throws:
      `IOException` - thrown if there was a problem closing the stream.

  - ### getDefaultEncoding

    public String getDefaultEncoding()
    Gets the default encoding to use if none is set in HTTP content-type, XML prolog and the rules based on content-type are not adequate.

    If it is `null` the content-type based rules are used.

    Returns:
      the default encoding to use.

  - ### getEncoding

    public String getEncoding()
    Gets the charset encoding of the XmlStreamReader.
    Returns:
      charset encoding.

  - ### read

    public int read(char[] buf, int offset, int len) throws IOException
    Reads the underlying reader's `read(char[], int, int)` method.
    Specified by:
      `read` in class `Reader`
    Parameters:
      `buf` - the buffer to read the characters into
      `offset` - The start offset
      `len` - The number of bytes to read
    Returns:
      the number of characters read or -1 if the end of stream
    Throws:
      `IOException` - if an I/O error occurs.